// serialServer.h

/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPFserial is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/
// Author: Marty Kraimer 
// Date: 13AUG98

#ifndef serialServerH
#define serialServerH

#include "serialStatus.h"

#define cmdWrite	0x1
#define cmdRead		0x2
#define cmdWriteRead    (cmdWrite|cmdRead)
//Following are additional options
#define cmdFlush	0x4
#define cmdSetEom 	0x8
//Following are for serialGetConfig
#define cmdGetConfig    0x1

/*
 * cmdFlush - flush before starting write and/or read
 * cmdSetEom - change current eom
 *
 * for example the following could be specified
 * message->cmd = cmdWriteRead|cmdFlush;
*/

/* Generic serial server messages

SerialConfigMessage.
   This just calls SerialPort::config.
   It returns an Int32Message. status is 0 for success.

Int32Message.
       cmdGetConfig
              Returns a SerialConfigMessage with current settings
Char8ArrayMessage
       cmdWrite        : write request
       cmdRead         : read request
       cmdWriteRead    : writeRead request


       other fields from input message

       timeoutUnits	timeout units.
       timeout		The timeout value in timeoutUnits
       extra		If >0 the maximum number of chars to read 

       If cmdSetEom is set

       eomSize		If 0 dont look for eom; otherwise must be 1 or 2
       eomString	1 or 2 character eomString

       Return values
			A Char8ArrayMessage message, which
                        contains any input characters read

                        status is one of the serialStatus values
*/

#endif /* serialServerH */
